%Here is how we represent states in the framework

%x is the position matrix whose first component is the timestep and for which x(i,:) is the
%vector of agent positions at timestep i.  'y' is a matrix whose
%first component is the timestep and for which y(i,:) is the vector of
%agent states at timestep i

%for example, the main function is modified to output [x,y] pairs

%also:

[x(1,1:n),y(1,1:n)] = initial_config(n,r,S); %this chooses a initial configuration of agent positions AND states




pdate trivially
  else  
    if (directed) %in the directed case 
     if (~good)   
       pos_action(k) = enact(directed_pattern_motion_rule2(b,p),b); %compute the directed action
       state(k) = 1; %again update state trivially
     end
     if good
       pos_action(k) = enact(directed_pattern_motion_rule4(b,p),b); %compute the directed action
       state(k) = 1; %again update state trivially
     end
    else %that is, in the case of deterministic algorithm on undirected line,
      state(k) = pattern_soliton(b,p);  %emerge the polarity   
      direction = direction_finder(b);  %check if a polarity is locally well-defined
      
      if ~good
       if (direction ~= 0)  %IF the polarity _is_ locally well defined, then 
        pos_action(k) = enact(-1*direction*directed_pattern_motion_rule2(b*(direction == -1) + fliplr(b)*(direction == 1),p),b); %evaluate action according to the polarity 
       else %otherwise
        pos_action(k) = 0; %the action is trivial
       end 
      end
      
      if good
       if (direction ~= 0)  %IF the polarity _is_ locally well defined, then 
        pos_action(k) = enact(-1*direction*directed_pattern_motion_rule4(b*(direction == -1) + fliplr(b)*(direction == 1),p),b); %evaluate action according to the polarity 
       else %otherwise
        pos_action(k) = 0; %the action is trivial
       end  
      end
    
    end
  
  end
 
 end

 
  norm_action = sum(abs(pos_action) + abs(state - y(i,:)));  %computes the norm of action, i.e. the number of agents that would take non-Stay actions in the given configuration

  if (norm_action == 0)  %if the norm of action is zero, i.e. nobody would take a non-Stay action,
      
      done = 1; %then we're at a fixed point, and we set the Done variable to 1 to stop the time loop
      
  else  %otherwise, 
      
      i = i+1; %we increment the time counter
      x(i,:) = x(i-1,:); %initialize the position configuration at time i to be the same as the configuration at the previous time step
      y(i,:) = y(i-1,:); %initialize the state configuration at time i to be the same as the configuration at the previous time step
      j = agent_choice(i,x(i-1,:),y(i-1,:)); %pick an agent to act via the function 'agent_choice', which can be random, ordered, whatever
      x(i,j) = x(i,j) + pos_action(j); %and make the chosen agent take its (motion) action (which might of course be to Stay) --
      y(i,j) = state(j); %and state change
      
      if ((y(i,j) ~= y(i-1,j)) | (x(i,j) ~= x(i-1,j))) %then, when something new happens, plot it and report the new to the screen
       x(i,:)
       %y(i,:) 
       xmin = min(xmin, x(i,1) - 3);
       xmax = max(xmax, x(i,n) + 3);
       axis([xmin xmax ymin ymax]);
       pause (0.001)  %a short pause makes it easier to see what's going on
       %scatter(x(i,:), y(i,:), size, y(i,:),'filled')   %this plots the current state of the system at timestep i -- agents size is 'size' and color is given by the state y(i,:) 
       plot(x(i,:),y(i,:),'--rs','LineWidth',2,'MarkerEdgeColor','k','MarkerSize',10);
       %scatter(x(i,:), ones(1,n), size, y(i,:),'filled')
      end 
      
  end
 
 end



 %   bb = (b ~= zeros(1,2*r+1));
  %   L = length(b);
  %   [XX,lv] = ismember(1,bb(1:r));
  %   [XX,rv] = ismember(1,fliplr(bb(r+2:L)));
  %   rv = L + 1 - rv;
     
  %   if (ismember(b(r+1),[1 5 6]) | ((rv - lv > r) & (rv <= (2*r + 1)) & (lv > 0)))
  %       if (direction == 0)
  %          pos_action(k) = 0;
  %       else
  %    
  %        if (direction == 1)
  %        two_discon = ((sum(bb(2:r)) <= 1) & (bb(1) == 1));
  %        else
  %        two_discon = ((sum(bb(r+2:2*r)) <= 1) & (bb(2*r+1) == 1));
  %        end
  %        pos_action(k) = enact(direction,b)*(~(two_discon)); 
  %       end
  %   else

